#include "jx_uart_send.h"

// UART2_RX串口通信消息头
const unsigned char g_uart_send_head_UART2_RX[] = {
  0xaa, 0x55
};

// UART2_RX串口通信消息尾
const unsigned char g_uart_send_foot_UART2_RX[] = {
  0x55, 0xaa
};

// 串口发送函数实现
void _uart_send_impl(int port, unsigned char* buff, int len) {
  // TODO: 调用项目实际的串口发送函数
  /*
  int i = 0;
  unsigned char c;
  for (i = 0; i < len; i++) {
    c = buff[i];
    printf("%02X ", c);
  }
  printf("\n");
  */
}

// action: com1
void _uart_com1() {
  uart_param_t param;
  int i = 0;
  unsigned char buff[UART_SEND_MAX] = {0};
  for (i = 0; i < UART_MSG_HEAD_LEN_UART2_RX; i++) {
      buff[i + 0] = g_uart_send_head_UART2_RX[i];
  }
  buff[2] = U_MSG_com1;
  for (i = 0; i < UART_MSG_FOOT_LEN_UART2_RX; i++) {
      buff[i + 3] = g_uart_send_foot_UART2_RX[i];
  }
  _uart_send_impl(2, buff, 5);
}

// action: com2
void _uart_com2(int dint) {
  uart_param_t param;
  int i = 0;
  unsigned char buff[UART_SEND_MAX] = {0};
  for (i = 0; i < UART_MSG_HEAD_LEN_UART2_RX; i++) {
      buff[i + 0] = g_uart_send_head_UART2_RX[i];
  }
  buff[2] = U_MSG_com2;
  param.d_int = dint;
  _int16_to_int32(&param);
  buff[3] = param.d_ucs[0];
  buff[4] = param.d_ucs[1];
  buff[5] = param.d_ucs[2];
  buff[6] = param.d_ucs[3];
  for (i = 0; i < UART_MSG_FOOT_LEN_UART2_RX; i++) {
      buff[i + 7] = g_uart_send_foot_UART2_RX[i];
  }
  _uart_send_impl(2, buff, 9);
}

// action: com3
void _uart_com3(double ddouble) {
  uart_param_t param;
  int i = 0;
  unsigned char buff[UART_SEND_MAX] = {0};
  for (i = 0; i < UART_MSG_HEAD_LEN_UART2_RX; i++) {
      buff[i + 0] = g_uart_send_head_UART2_RX[i];
  }
  buff[2] = U_MSG_com3;
  param.d_double = ddouble;
  _float_to_double(&param);
  buff[3] = param.d_ucs[0];
  buff[4] = param.d_ucs[1];
  buff[5] = param.d_ucs[2];
  buff[6] = param.d_ucs[3];
  buff[7] = param.d_ucs[4];
  buff[8] = param.d_ucs[5];
  buff[9] = param.d_ucs[6];
  buff[10] = param.d_ucs[7];
  for (i = 0; i < UART_MSG_FOOT_LEN_UART2_RX; i++) {
      buff[i + 11] = g_uart_send_foot_UART2_RX[i];
  }
  _uart_send_impl(2, buff, 13);
}

